<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TransformationUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/core/transformations/TransformationUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.core.transformations;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.UniqueEList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.AllocUtils;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.ConfigUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.deployment.tools.DepUtils;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.core.Activator;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Slot;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/core/transformations/TransformationUtil.html">TransformationUtil</a> {
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> applyInstanceConfigurators(InstanceSpecification instance) {
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  		<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  			InstanceSpecification subInstance = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  			<strong class="jxr_keyword">if</strong> (!DepUtils.isShared(slot) &amp;&amp; (subInstance != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  				<strong class="jxr_keyword">if</strong> (slot.getDefiningFeature() instanceof Property) {
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  					ConfigUtils.configureInstance(subInstance, (Property) slot.getDefiningFeature(), instance);
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  				}
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  				applyInstanceConfigurators(subInstance);
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  			}
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  		}
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  	}
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> propagateAllocation(InstanceSpecification instance) {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  		propagateAllocation(instance, <strong class="jxr_keyword">new</strong> UniqueEList&lt;InstanceSpecification&gt;());
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	}
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> propagateAllocation(InstanceSpecification instance, EList&lt;InstanceSpecification&gt; nodes) {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  		<em class="jxr_comment">// create copy of node (otherwise, more and more nodes get aggregated.</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  		UniqueEList&lt;InstanceSpecification&gt; nodesCopy = <strong class="jxr_keyword">new</strong> UniqueEList&lt;InstanceSpecification&gt;();
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  		nodesCopy.addAll(nodes);
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  		nodesCopy.addAll(AllocUtils.getNodes(instance));
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  		<strong class="jxr_keyword">for</strong> (Slot slot : instance.getSlots()) {
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  			InstanceSpecification subInstance = DepUtils.getInstance(slot);
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  			<strong class="jxr_keyword">if</strong> (subInstance != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  				<strong class="jxr_keyword">if</strong> (DepUtils.isShared(slot)) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  					<strong class="jxr_keyword">for</strong> (InstanceSpecification node : nodesCopy) {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  						Activator.log.info(String.format(<span class="jxr_string">"Propagate node allocation: %s to %s"</span>, subInstance.getName(), node.getName())); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  						AllocUtils.allocate(subInstance, node);
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  					}
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  				}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  				<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  					propagateAllocation(subInstance, nodesCopy);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  			}
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		}
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	}
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
